Index: trunk/zoo-project/COMMITTERS
===================================================================
--- trunk/zoo-project/COMMITTERS	(revision 534)
+++ trunk/zoo-project/COMMITTERS	(revision 536)
@@ -17,8 +17,12 @@
 lucadelu      Luca DELUCCHI
 	      lucadeluge at gmail.com
-neteler       Markus Neteler
+nbozon	      Nicolas BOZON
+	      nicolas.bozon@gmail.com
+neteler       Markus NETELER
 	      neteler at osgeo.org
 nmarco        Marco NEGRETTI
 	      marco.negretti at polimi.it
+knut	      Knut LANDMARK
+	      Knut.Landmark@ffi.no
 reluc         René-Luc D'HONT
 	      rldhont at gmail.com
Index: trunk/zoo-project/zoo-services/cgal/cgi-env/Delaunay.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/cgal/cgi-env/Delaunay.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/cgal/cgi-env/Delaunay.zcfg	(revision 536)
@@ -1,5 +1,5 @@
 [Delaunay]
  Title = Delaunay Triangulation. 
- Abstract = Computes the edges of Voronoi diagram of a set of data points.
+ Abstract = Computes the edges of a Delaunay triangulation for a set of data points.
  processVersion = 2
  storeSupported = true
Index: trunk/zoo-project/zoo-services/cgal/cgi-env/Voronoi.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/cgal/cgi-env/Voronoi.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/cgal/cgi-env/Voronoi.zcfg	(revision 536)
@@ -1,5 +1,5 @@
 [Voronoi]
  Title = Voronoi Diagram. 
- Abstract = Computes the edges of Voronoi diagram of a set of data points.
+ Abstract = Computes the edges of Voronoi diagram for a set of data points.
  Profile = urn:ogc:wps:1.0.0:voronoi
  processVersion = 2
Index: trunk/zoo-project/zoo-services/gdal/contour/cgi-env/Gdal_Contour.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/gdal/contour/cgi-env/Gdal_Contour.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/gdal/contour/cgi-env/Gdal_Contour.zcfg	(revision 536)
@@ -1,4 +1,4 @@
 [Gdal_Contour]
- Title = Tool to builds vector contour lines from a raster elevation model.
+ Title = Builds vector contour lines from a raster elevation model.
  Abstract = http://www.gdal.org/gdal_contour.html
  processVersion = 1
Index: trunk/zoo-project/zoo-services/gdal/grid/cgi-env/Gdal_Grid.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/gdal/grid/cgi-env/Gdal_Grid.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/gdal/grid/cgi-env/Gdal_Grid.zcfg	(revision 536)
@@ -1,5 +1,5 @@
 [Gdal_Grid]
- Title = Convert raster data from one format to another. 
- Abstract = Converts raster data between different formats.
+ Title =  Computes a regular grid (raster) from scattered data read from a vector data source. 
+ Abstract = http://www.gdal.org/gdal_grid.html
  processVersion = 1
  storeSupported = true
Index: trunk/zoo-project/zoo-services/gdal/ndvi/cgi-env/ExtractNDVI.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/gdal/ndvi/cgi-env/ExtractNDVI.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/gdal/ndvi/cgi-env/ExtractNDVI.zcfg	(revision 536)
@@ -1,5 +1,5 @@
 [ExtractNDVI]
  Title = Normalized Difference Vegetation Index. 
- Abstract = Create raster file containing the Normalized Difference Vegetation Index. 
+ Abstract = Computes the Normalized Difference Vegetation Index in a new raster file. 
  Profile = urn:ogc:wps:1.0.0:buffer
  processVersion = 2
Index: trunk/zoo-project/zoo-services/gdal/profile/cgi-env/GdalExtractProfile.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/gdal/profile/cgi-env/GdalExtractProfile.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/gdal/profile/cgi-env/GdalExtractProfile.zcfg	(revision 536)
@@ -1,5 +1,5 @@
 [GdalExtractProfile]
- Title = Convert raster data from one format to another. 
- Abstract = Converts raster data between different formats.
+ Title = Extract elevation values along a line. 
+ Abstract = Fetch the x,y,z values of a DEM raster file along a linestring
  processVersion = 1
  storeSupported = true
@@ -12,5 +12,5 @@
  <DataInputs>
   [RasterFile]
-   Title = The name fo the MNT file
+   Title = The name of the MNT file
    Abstract = The file containing elevation model relative to the dataPath defined in the ZOO-Project main configuration file.
    minOccurs = 0
@@ -43,5 +43,5 @@
   [Profile]
    Title = The resulting profile
-   Abstract = GeoJSON string containing the X Y Z values where (X,Y) is corresponding to the original coordinates and Z the elevation value 
+   Abstract = GeoJSON string containing the X Y Z values where (X,Y) is corresponding to the original coordinates and the elevation value. 
    <ComplexData>
     <Default>
Index: trunk/zoo-project/zoo-services/gdal/translate/cgi-env/Gdal_Translate.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/gdal/translate/cgi-env/Gdal_Translate.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/gdal/translate/cgi-env/Gdal_Translate.zcfg	(revision 536)
@@ -1,5 +1,5 @@
 [Gdal_Translate]
  Title = Convert raster data from one format to another. 
- Abstract = Converts raster data between different formats.
+ Abstract = http://www.gdal.org/gdal_translate.html
  processVersion = 1
  storeSupported = true
Index: trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/BoundaryPy.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/BoundaryPy.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/BoundaryPy.zcfg	(revision 536)
@@ -1,4 +1,4 @@
 [BoundaryPy]
- Title = Compute boundary.
+ Title = Computes boundary.
  Abstract = A new geometry object is created and returned containing the boundary of the geometry on which the method is invoked. 
  processVersion = 1
Index: trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/BufferPy.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/BufferPy.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/BufferPy.zcfg	(revision 536)
@@ -1,5 +1,5 @@
 [BufferPy]
- Title = Create a buffer around a polygon. 
- Abstract = Create a buffer around a single polygon. Accepts the polygon as GML and provides GML output for the buffered feature. 
+ Title = Creates a buffer around a polygon. 
+ Abstract = Creates a buffer around a single polygon. Accepts the polygon as GML and provides GML output for the buffered feature. 
  Profile = urn:ogc:wps:1.0.0:buffer
  processVersion = 2
Index: trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/CentroidPy.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/CentroidPy.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/CentroidPy.zcfg	(revision 536)
@@ -1,5 +1,5 @@
 [Clean]
- Title = Extract the feature that have a valid geometry field. 
- Abstract = Extract the feature that have a valid geometry field.
+ Title = Computes the centroid of a polygon 
+ Abstract = Computes the centroid of a polygon that have a valid geometry field.
  processVersion = 1
  storeSupported = true
Index: trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/ConvexHullPy.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/ConvexHullPy.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/ConvexHullPy.zcfg	(revision 536)
@@ -1,4 +1,4 @@
 [ConvexHullPy]
- Title = Compute convex hull.
+ Title = Computes convex hull.
  Abstract = A new geometry object is created and returned containing the convex hull of the geometry on which the method is invoked.
  processVersion = 1
Index: trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/DifferencePy.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/DifferencePy.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/DifferencePy.zcfg	(revision 536)
@@ -1,4 +1,4 @@
 [DifferencePy]
- Title = Compute difference. . 
+ Title = Computes difference. 
  Abstract = Generates a new geometry which is the region of this geometry with the region of the other geometry removed.
  Profile = urn:ogc:wps:1.0.0:difference
Index: trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/IntersectionPy.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/IntersectionPy.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/IntersectionPy.zcfg	(revision 536)
@@ -1,4 +1,4 @@
 [IntersectionPy]
- Title = Compute intersection. 
+ Title = Computes intersection. 
  Abstract = Generates a new geometry which is the region of intersection of the two geometries operated on.
  Profile = urn:ogc:wps:1.0.0:union
Index: trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/SymDifferencePy.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/SymDifferencePy.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/SymDifferencePy.zcfg	(revision 536)
@@ -1,4 +1,4 @@
 [SymDifferencePy]
- Title = Compute symmetric difference. 
+ Title = Computes symmetric difference. 
  Abstract = Generates a new geometry which is the symmetric difference of this geometry and the other geometry.
  Profile = urn:ogc:wps:1.0.0:symmetricdifference
Index: trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/UnionPy.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/UnionPy.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/UnionPy.zcfg	(revision 536)
@@ -1,4 +1,4 @@
 [UnionPy]
- Title = Compute union. 
+ Title = Computes union. 
  Abstract = Generates a new geometry which is the region of union of the two geometries operated on.
  Profile = urn:ogc:wps:1.0.0:union
Index: trunk/zoo-project/zoo-services/ogr/base-vect-ops/cgi-env/Boundary.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/ogr/base-vect-ops/cgi-env/Boundary.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/ogr/base-vect-ops/cgi-env/Boundary.zcfg	(revision 536)
@@ -1,4 +1,4 @@
 [Boundary]
- Title = Compute boundary.
+ Title = Computes boundary.
  Abstract = This service shall return a feature callection representing the combinatorial boundary of each geometry in the InputPolygon feature collection.
  processVersion = 1
Index: trunk/zoo-project/zoo-services/ogr/base-vect-ops/cgi-env/Centroid.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/ogr/base-vect-ops/cgi-env/Centroid.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/ogr/base-vect-ops/cgi-env/Centroid.zcfg	(revision 536)
@@ -1,4 +1,4 @@
 [Centroid]
- Title = Get the centroid of a polygon. 
+ Title = Computes the centroid of a polygon. 
  Abstract = This service shall return the point that is the geometric centre of gravity of the geometry InputPolygon.
  Profile = urn:ogc:wps:1.0.0:centroid
Index: trunk/zoo-project/zoo-services/ogr/base-vect-ops/cgi-env/Difference.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/ogr/base-vect-ops/cgi-env/Difference.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/ogr/base-vect-ops/cgi-env/Difference.zcfg	(revision 536)
@@ -1,5 +1,5 @@
 [Difference]
- Title = Compute difference. . 
- Abstract = This function SHALL return a bag of geometry values representing the closure of the set difference between the two geometries InputEntity1 and InputEntity2. The difference is the set of all points which lie on InputEntity1 but not on InputEntity2.
+ Title = Compute difference. 
+ Abstract = This function shall return a bag of geometry values representing the closure of the set difference between the two geometries InputEntity1 and InputEntity2. The difference is the set of all points which lie on InputEntity1 but not on InputEntity2.
  Profile = urn:ogc:wps:1.0.0:difference
  processVersion = 2
Index: trunk/zoo-project/zoo-services/ogr/base-vect-ops/cgi-env/GetArea.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/ogr/base-vect-ops/cgi-env/GetArea.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/ogr/base-vect-ops/cgi-env/GetArea.zcfg	(revision 536)
@@ -1,5 +1,5 @@
 [GetArea]
  Title = Compute geometry area.
- Abstract = Computes the area for a geometry
+ Abstract = Computes the area of a geometry
  processVersion = 2
  storeSupported = true
Index: trunk/zoo-project/zoo-services/ogr/base-vect-ops/cgi-env/Simplify.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/ogr/base-vect-ops/cgi-env/Simplify.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/ogr/base-vect-ops/cgi-env/Simplify.zcfg	(revision 536)
@@ -1,4 +1,4 @@
 [Simplify]
- Title = Create a buffer around a polygon. 
+ Title = Simplifies polygons geometries. 
  Abstract = This service shall return a feature collection representing all simplified geometries with all their vertices within the distance of the original geometry defined by the given tolerance.
  Profile = urn:ogc:wps:1.0.0:buffer
Index: trunk/zoo-project/zoo-services/ogr/ogr2ogr/cgi-env/Ogr2Ogr.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/ogr/ogr2ogr/cgi-env/Ogr2Ogr.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/ogr/ogr2ogr/cgi-env/Ogr2Ogr.zcfg	(revision 536)
@@ -1,5 +1,5 @@
 [Ogr2Ogr]
- Title = Convert vector data from one format to another. 
- Abstract = Converts vector data between different formats.
+ Title = Converts vector data from one format to another. 
+ Abstract = http://www.gdal.org/ogr2ogr.html
  processVersion = 1
  storeSupported = true
Index: trunk/zoo-project/zoo-services/openoffice/cgi-env/OdtConverter.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/openoffice/cgi-env/OdtConverter.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/openoffice/cgi-env/OdtConverter.zcfg	(revision 536)
@@ -1,5 +1,5 @@
 [OdtConverter]
- Title = Convert raster data from one format to another. 
- Abstract = Converts raster data between different formats.
+ Title = Converts Open Documents. 
+ Abstract = Converts open documents.
  processVersion = 1
  storeSupported = true
@@ -13,5 +13,5 @@
   [InputDoc]
    Title = The input data source name
-   Abstract = The input data source name to use as source for convertion.
+   Abstract = The input data source name
    minOccurs = 1
    maxOccurs = 1
@@ -23,5 +23,5 @@
   [OutputDoc]
    Title = The output data source name
-   Abstract = The output data source name to use as source for convertion.
+   Abstract = The output data source name to use as source.
    minOccurs = 1
    maxOccurs = 1
Index: trunk/zoo-project/zoo-services/openoffice/cgi-env/Xml2Pdf.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/openoffice/cgi-env/Xml2Pdf.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/openoffice/cgi-env/Xml2Pdf.zcfg	(revision 536)
@@ -1,5 +1,5 @@
 [Xml2Pdf]
- Title = Convert raster data from one format to another. 
- Abstract = Converts raster data between different formats.
+ Title = Convert XML and Open Document to PDF format. 
+ Abstract = Converts XML to PDF format.
  processVersion = 1
  storeSupported = true
Index: trunk/zoo-project/zoo-services/qrencode/cgi-env/QREncode.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/qrencode/cgi-env/QREncode.zcfg	(revision 534)
+++ trunk/zoo-project/zoo-services/qrencode/cgi-env/QREncode.zcfg	(revision 536)
@@ -1,5 +1,5 @@
 [QREncode]
- Title = Encode a string into its QR Code
- Abstract = Multiply two values and stor the result in Result.
+ Title = Encode a string into a QR Code
+ Abstract = Multiply two values and store the result in Result.
  processVersion = 1
  storeSupported = true