Index: trunk/thirds/saga2zcfg/saga2zcfg.c
===================================================================
--- trunk/thirds/saga2zcfg/saga2zcfg.c	(revision 636)
+++ trunk/thirds/saga2zcfg/saga2zcfg.c	(revision 637)
@@ -17,5 +17,5 @@
 const char* cleanAbstract(CSG_String abstract){
   char* tmp=strdup(abstract.b_str());
-  CSG_String val=CSG_String("")+tmp;
+  CSG_String val=CSG_String(" ")+tmp;
   if(val.Contains("¸")){
     val.Replace("¸"," ");
@@ -23,4 +23,7 @@
   if(val.Contains("\n")){
     val.Replace("\n","<br/>");
+  }
+  if(val.Contains("\r")){
+    val.Replace("\r","");
   }
   if(val.Contains("<")){
@@ -42,5 +45,5 @@
     fprintf(stdout,"  Abstract = %s\n",CSG_String(param->Get_Name()).b_str());
   else{
-    fprintf(stdout,"  Abstract = %s\n",cleanAbstract(CSG_String(param->Get_Description()).BeforeFirst('\n')));
+    fprintf(stdout,"  Abstract = %s\n",cleanAbstract(CSG_String(param->Get_Description())));
   }
   if(!out){
@@ -145,11 +148,20 @@
 
 	  mkdir(library->Get_Library_Name().b_str(),0755);
+	  fprintf(stderr,"%s %s \n",library->Get_Library_Name().b_str(),CSG_String(module->Get_ID()).b_str());
 	  FILE *stdout1=fopen((library->Get_Library_Name()+"/"+module->Get_ID()+".zcfg").b_str(),"w+");
 	  fprintf(stdout1,"[%d]\n",j);
 	  fprintf(stdout1," Title = %s\n",module->Get_Name().b_str());
-	  if(CSG_String(module->Get_Description()).is_Empty())
+	  if(CSG_String(module->Get_Description()).is_Empty() ||
+	     module->Get_Description().Length()<module->Get_Name().Length() )
 	    fprintf(stdout1," Abstract = %s\n",module->Get_Name().b_str());
-	  else
-	    fprintf(stdout1," Abstract = %s\n",cleanAbstract(module->Get_Description()));
+	  else{
+	    const char *tmp=cleanAbstract(module->Get_Description());
+	    if(tmp==NULL || strlen(tmp)<7 ){
+	      fprintf(stdout1," Abstract = %s\n",module->Get_Name().b_str());
+	    }
+	    else{
+	      fprintf(stdout1," Abstract = %s\n",tmp);
+	    }
+	  }
 	  fprintf(stdout1," storeSupported = true\n");
 	  fprintf(stdout1," statusSupported = true\n");
@@ -294,5 +306,5 @@
 		    for(int l=0;l<clen;l++){
 		      //fprintf(stdout1,"%d",l);
-		      fprintf(stdout1,"%s",cleanAbstract(CSG_String(choice->Get_Item(l))));
+		      fprintf(stdout1,"%s",(CSG_String(choice->Get_Item(l))).b_str());
 		      if(l+1<clen)
 			fprintf(stdout1,",");
@@ -302,5 +314,5 @@
 		  fprintf(stdout1,"   <Default>\n");
 		  if( !param->Get_Data()->Get_Default().is_Empty() ){
-		    fprintf(stdout1,"    value = %s\n",cleanAbstract(CSG_String(choice->Get_Item(atoi(param->Get_Data()->Get_Default())))));
+		    fprintf(stdout1,"    value = %s\n",CSG_String(choice->Get_Item(atoi(param->Get_Data()->Get_Default()))).b_str());
 		  }
 		  fprintf(stdout1,"   </Default>\n");
Index: trunk/zoo-project/zoo-kernel/configure.ac
===================================================================
--- trunk/zoo-project/zoo-kernel/configure.ac	(revision 636)
+++ trunk/zoo-project/zoo-kernel/configure.ac	(revision 637)
@@ -373,8 +373,8 @@
 	OTB_ENABLED=""
 else
-    if test -z "$ITKVERS" 
-    then
-        ITKVERS="4.5"
-    fi
+	if test -z "$ITKVERS" 
+    	then
+		ITKVERS="4.5"
+    	fi
 	OTB_ENABLED="-DUSE_OTB"
 	OTB_LDFLAGS="-L$OTBPATH/lib/otb -lOTBIO -lOTBCommon -lOTBApplicationEngine -L$ITKPATH/lib -lITKBiasCorrection-$ITKVERS -lITKCommon-$ITKVERS -lITKIOImageBase-$ITKVERS -lITKKLMRegionGrowing-$ITKVERS -lITKLabelMap-$ITKVERS -lITKMesh-$ITKVERS -lITKMetaIO-$ITKVERS -lITKOptimizers-$ITKVERS -lITKPath-$ITKVERS -lITKPolynomials-$ITKVERS -lITKQuadEdgeMesh-$ITKVERS -lITKSpatialObjects-$ITKVERS -lITKStatistics-$ITKVERS -lITKVNLInstantiation-$ITKVERS -lITKWatersheds-$ITKVERS -litkNetlibSlatec-$ITKVERS -litksys-$ITKVERS -litkdouble-conversion-$ITKVERS -litkv3p_lsqr-$ITKVERS -litkv3p_netlib-$ITKVERS -litkvcl-$ITKVERS -litkvnl-$ITKVERS -litkvnl_algo-$ITKVERS -litkzlib-$ITKVERS"
@@ -439,6 +439,6 @@
 			[], [AC_MSG_ERROR([could not find header file $i related to SAGA-GIS])])
 	LIBS_SAVE="$LIBS"
+	AC_CHECK_LIB([saga_api], [SG_Set_UI_Callback,SG_Get_Module_Library_Manager])
 	AC_LANG_POP([C++])
-	AC_CHECK_LIB([saga_api], [SG_Set_UI_Callback,SG_Get_Module_Library_Manager])
 fi
 AC_SUBST([SAGA_CPPFLAGS])
Index: trunk/zoo-project/zoo-kernel/service_internal_saga.c
===================================================================
--- trunk/zoo-project/zoo-kernel/service_internal_saga.c	(revision 636)
+++ trunk/zoo-project/zoo-kernel/service_internal_saga.c	(revision 637)
@@ -25,6 +25,18 @@
 #include <stdlib.h>
 #include <limits.h>
+#include <locale.h>
+#include <wx/string.h>
+#include <wx/app.h>
+#include <api_core.h>
+#include <data_manager.h>
+#include <module_library.h>
+#define _ZOO_SAGA
 #include "service_internal_saga.h"
 #include "mimetypes.h"
+
+/**
+ * Global SAGA-GIS output counter 
+ */
+int sagaOutputCounter=0;
 
 /**
Index: trunk/zoo-project/zoo-kernel/service_internal_saga.h
===================================================================
--- trunk/zoo-project/zoo-kernel/service_internal_saga.h	(revision 636)
+++ trunk/zoo-project/zoo-kernel/service_internal_saga.h	(revision 637)
@@ -28,19 +28,7 @@
 #pragma once 
 
-#include <locale.h>
-#define _WX_WXCRTVARARG_H_
-#include <wx/string.h>
-#include <wx/app.h>
-#include <api_core.h>
-#include <data_manager.h>
-#include <module_library.h>
-
 #include "service.h"
 #include "service_internal.h"
 
-/**
- * Global SAGA-GIS output counter 
- */
-int sagaOutputCounter=0;
 int zoo_saga_support(maps**,map*,service*,maps**,maps**);
 